%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% Calculate the interdependence between categorical attribute Ai and Aj %%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function dependen_value = Dependen_Measure(frequency_in_data, x, attr_1, attr_2, co_occurrence_in_data)
%%%%%%%% attr_1 and attr_2 are the index of attribute %%%%%%%%%%%%
[n, d] = size(x);
[~, m] = size(frequency_in_data);

informa_attr_12 = 0;
entropy_attr_12 = 0;

for i = 1:m
    proba_i = frequency_in_data(attr_1, i)/n;
    for j = 1:m
        if attr_1 < attr_2
            index_co = (attr_1-1)*d-(attr_1*(attr_1-1)/2)+(attr_2-attr_1);
            proba_ij = co_occurrence_in_data(i, j, index_co)/n;
        else if attr_1 > attr_2
                index_co = (attr_2-1)*d-(attr_2*(attr_2-1)/2)+(attr_1-attr_2);
                proba_ij = co_occurrence_in_data(j, i, index_co)/n;
            else
                proba_ij = 1;
            end
        end
        proba_j = frequency_in_data(attr_2, j)/n;
        if (proba_i~=0) && (proba_j~=0) && (proba_ij~=0)
            informa_value = proba_ij * log2(proba_ij/(proba_i*proba_j));
            entropy_value = proba_ij * log2(proba_ij);
            informa_attr_12 = informa_attr_12 + informa_value;
            entropy_attr_12 = entropy_attr_12 - entropy_value;
        end
    end
end

if entropy_attr_12==0
    dependen_value = 1;
else
    dependen_value = informa_attr_12/entropy_attr_12;
end
            